<?php
/**
 * $Id: admin_group.php 56 2010-10-13 01:11:47Z michiel $
 * 
 * Group Admin plugin for e107 v7xx - by Michiel Horvers
 * This module for the e107 .7+ website system
 * Copyright Michiel Horvers 2010
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * Initial Creation Date: 31 aug. 2010
 * $HeadURL: svn://ubusrv/echo2/GroupStyle/frontliners.eu/fl_plugins/groupstyle/admin_group.php $
 * 
 * Revision: $LastChangedRevision: 56 $
 * Last Modified: $LastChangedDate: 2010-10-13 03:11:47 +0200 (wo, 13 okt 2010) $
 *
 */
require_once('../../class2.php');

if (!defined('e107_INIT')) {
    exit;
}

if (!getperms('P')) {
    header('location:' . e_HTTP . 'index.php');
    exit;
}

require_once(e_ADMIN . 'auth.php');

if (!defined('ADMIN_WIDTH')) {
    define(ADMIN_WIDTH, 'width:100%;');
}

if (file_exists(e_PLUGIN . 'groupstyle/languages/admin/' . e_LANGUAGE . '.php')) {
	include_lan(e_PLUGIN . 'groupstyle/languages/admin/' . e_LANGUAGE . '.php');
} else {
	include_lan(e_PLUGIN . 'groupstyle/languages/admin/English.php');
}

global $GSTYLE_PREF, $gs_obj;
require_once(e_PLUGIN.'groupstyle/includes/groupstyle_class.php');
if (!isset($gs_obj)) {
	$gs_obj = new groupstyle();
}

if ($_POST) {
	$action = $_POST['action'];
	$id = $_POST['id'];
} else if (e_QUERY) {
	$tmp = explode(".", e_QUERY);
	$action = $tmp[0];
	$id = intval(varset($tmp[1],0));
	unset($tmp);
} else {
	$action = "show";
	$id = false;
}

if(isset($_POST['updateEnabled'])) {
	$posted = explode(",", $_POST['posted']);

	foreach($posted as $post) {
		$state = ($_POST['style_custom_'.$post] ? 1 : 0);
		$sql->db_Update("gstyle_style", "style_custom = $state where style_class = $post");
	}
	
	if ($_POST['memb_text']) {
		$GSTYLE_PREF['memb_text'] = $tp->toDB($_POST['memb_text']);
	}
	if ($_POST['admin_text']) {
		$GSTYLE_PREF['admin_text'] = $tp->toDB($_POST['admin_text']);
	}
	$gs_obj->save_prefs();
}

if (isset($_POST['preview'])) {
	$preview = $_POST['style_style'];
	$action = "edit";
}

if (isset($_POST['savestyle'])) {
	if ($_POST['id']) {
		$style = $tp->toDB($_POST['style_style']);
		
		if ($sql->db_Update("gstyle_style", "style_style = '$style', style_custom = 1 where style_class = $id")) {
			$gst_msg = ADLAN_GST_UPDOK;
			$action = "show";
		} else {
			$gst_msg = ADLAN_GST_UPDNOK;
		}
	}
}

if ($action == "edit") {
	if (!getperms('0')) {
		$restrict = " AND (userclass_editclass = 254 OR userclass_editclass in (".USERCLASS.")) ";
	} else {
		$restrict = "";
	}
	
	if ($id < 250) {
		$query = "
			SELECT
				s.*
				,c.userclass_name
			FROM
				#gstyle_style s,
				#userclass_classes c
			WHERE
				style_class = $id
				AND userclass_id = $id 
				$restrict
		";
	} else {
		switch ($id) {
			case e_UC_ADMIN:
				$userclass_name = ADLAN_GST_GC12;
				break;
			case e_UC_MEMBER:
				$userclass_name = ADLAN_GST_GC11;
				break;
		}
		
		$query = "
			SELECT
				*
			FROM
				#gstyle_style
			WHERE
				style_class = $id
				$restrict
		";
	}
	$sql->db_Select_gen($query);
	extract($sql->db_Fetch());
	if (isset($preview)) {
		$style_style = $preview;
	}
	
	$gst_text = "
		<form action='".e_SELF."' id='dataform' method='post'>
		<table class='fborder' style='".ADMIN_WIDTH."'>
			<tr>
				<td class='fcaption' colspan='2' style='text-align:left'>" . ADLAN_GST_GC08 . "</td>
			</tr>
		
			<tr>
				<td style='width:30%; text-align:left' class='forumheader'><strong>".ADLAN_GST_GC02."</strong></td>
				<td style='width:70%; text-align:left' class='forumheader2'>$userclass_name</td>
			</tr>
			<tr>
				<td style='text-align:left' class='forumheader'><strong>".ADLAN_GST_GC09."</strong></td>
				<td style='text-align:left' class='forumheader2'>
					<textarea class='tbox' rows='4' cols='60' style='width:80%' name='style_style'>" . $tp->toForm($style_style). "</textarea>
				</td>
			</tr>
			<tr>
				<td style='text-align:left' class='forumheader'><strong>".ADLAN_GST_GC04."</strong></td>
				<td style='text-align:left' class='forumheader2'>
					<div style='$style_style'>$userclass_name</div>
				</td>
			</tr>
			
			<tr>
				<td class='fcaption' colspan='2' style='text-align: center'>
					<input type='hidden' name='id' value='$id' />
					<input type='submit' class='button' name='preview' value='".ADLAN_GST_GC10."' />
					<input type='submit' class='button' name='savestyle' value='".ADLAN_GST_UPD."' />
				</tr>
			</tr>
		</table></forum>
	";
	
}

if ($action == "show" || $action == "") {
	$gst_text = "
		<form action='".e_SELF."?show' id='dataform' method='post'>
		<table class='fborder' style='".ADMIN_WIDTH."'>
			<tr>
				<td class='fcaption' colspan='5' style='text-align:left'>" . ADLAN_GST_GC01 . "</td>
			</tr>
			<tr>
				<td class='forumheader2' colspan='5' style='text-align:left'><b>$gst_msg</b>&nbsp;</td>
			</tr>
		
			<tr>
				<td style='width:20%; text-align:center' class='fcaption'><strong>".ADLAN_GST_GC02."</strong></td>
				<td style='width:40%; text-align:center' class='fcaption'><strong>".ADLAN_GST_GC03."</strong></td>
				<td style='width:30%; text-align:center' class='fcaption'><strong>".ADLAN_GST_GC04."</strong></td>
				<td style='width:5%; text-align:center' class='fcaption'><strong>".ADLAN_GST_GC05."</strong></td>
				<td style='width:5%; text-align:center' class='fcaption'>&nbsp;</td>
			</tr>
		
	";
	
	if (!getperms('0')) {
		$restrict = " WHERE userclass_editclass = 254 OR userclass_editclass in (".USERCLASS.") ";
	} else {
		$restrict = "";
	}
	
	$posted = "";
	
	if ($sql->db_Select("userclass_classes", "*", "$restrict order by userclass_name", "nowhere")) {
		$ucList = $sql->db_getList();

		//Members
		$ucList[] = array (
			'userclass_id' => e_UC_MEMBER
			,'userclass_name' => $GSTYLE_PREF['memb_text']
			,'userclass_description' => ADLAN_GST_GC13
			,'userclass_editclass' => e_UC_ADMIN
		);
		//Admins
		$ucList[] = array (
			'userclass_id' => e_UC_ADMIN
			,'userclass_name' => $GSTYLE_PREF['admin_text']
			,'userclass_description' => ADLAN_GST_GC12
			,'userclass_editclass' => e_UC_ADMIN
		);
		
		
		foreach ($ucList as $uClass) {
			$id = $uClass['userclass_id'];
			$posted .= ($posted != "" ? "," . $id : $id);
			
			if ($sql->db_Select("gstyle_style", "*", "style_class = ".$uClass['userclass_id'])) {
				$sClass = $sql->db_Fetch();
			} else {
				//doesn't exists yet... create it
				$sClass['style_class'] = $id;
				$sClass['style_custom'] = 0;
				$sClass['style_style'] = '';
				
				$sql->db_Insert("gstyle_style",
					$sClass['style_class']
					.",".$sClass['style_custom']
					.",'".$sClass['style_style']."'" 
				);
			}
			
			if ($sClass['style_custom']) {
				$example = "<div style='".$sClass['style_style']."'>".$uClass['userclass_name']."</div>"; 
			} else {
				$example = $uClass['userclass_name'];
			}
			
			if ($uClass['userclass_id'] == e_UC_MEMBER) {
				$name = "<input type='text' class='tbox' name='memb_text' value='".$uClass['userclass_name']."' size='20' maxlength='20'>";
			} else if ($uClass['userclass_id'] == e_UC_ADMIN) {
				$name = "<input type='text' class='tbox' name='admin_text' value='".$uClass['userclass_name']."' size='20' maxlength='20'>";
			} else {
				$name = $uClass['userclass_name'];
			}
	
			$gst_text .= "<tr>
				<td style='text-align:left' class='forumheader3'>$name</td>
				<td style='text-align:left' class='forumheader3'>".$tp->toHTML($uClass['userclass_description'])."</td>
				<td style='text-align:center' class='forumheader3'>$example</td>
				<td style='text-align:center' class='forumheader3'>
					<input name='style_custom_$id' value='1' type='checkbox' class='tbox' style='border:0;' " . ($sClass['style_custom'] == "1" ? 'checked="checked"':'') . " />
				</td>
				
				<td style='text-align:center' class='forumheader3'>
					<a href='".e_SELF."?edit.$id'>".ADMIN_EDIT_ICON."</a>
				</td>
				</tr>\n
			";
		}
		$gst_text .= "
			<tr>
				<td class='fcaption' colspan='3'>&nbsp;</td>
				<td class='fcaption' style='text-align: center'>
					<input type='hidden' name='posted' value='$posted' />
					<input type='submit' class='button' name='updateEnabled' value='".ADLAN_GST_GC07."' />
				</td>
				<td class='fcaption' style='text-align: center'></td>
				
			</tr>
		";
	} else {
		$gst_text .= "<tr><td colspan='5' style='text-align:center' class='forumheader3' >".ADLAN_GST_GC06."</td></tr>";
	}
	$gst_text .= "</table></form>";
}

$ns->tablerender(ADLAN_GST_GC01, $gst_text);
require_once(e_ADMIN . 'footer.php');


?>