<?php
/**
 * $Id: admin_user.php 9 2010-09-07 23:10:48Z michiel $
 * 
 * Group Admin plugin for e107 v7xx - by Michiel Horvers
 * This module for the e107 .7+ website system
 * Copyright Michiel Horvers 2010
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * Initial Creation Date: 31 aug. 2010
 * $HeadURL: svn://ubusrv/echo2/GroupStyle/frontliners.eu/fl_plugins/groupstyle/admin_user.php $
 * 
 * Revision: $LastChangedRevision: 9 $
 * Last Modified: $LastChangedDate: 2010-09-08 01:10:48 +0200 (wo, 08 sep 2010) $
 *
 */
require_once('../../class2.php');

if (!defined('e107_INIT')) {
    exit;
}

if (!getperms('P')) {
    header('location:' . e_HTTP . 'index.php');
    exit;
}

require_once(e_ADMIN . 'auth.php');

$LISTSIZE = 15;

if (!defined('ADMIN_WIDTH')) {
    define(ADMIN_WIDTH, 'width:100%;');
}

if (file_exists(e_PLUGIN . 'groupstyle/languages/admin/' . e_LANGUAGE . '.php')) {
	include_lan(e_PLUGIN . 'groupstyle/languages/admin/' . e_LANGUAGE . '.php');
} else {
	include_lan(e_PLUGIN . 'groupstyle/languages/admin/English.php');
}

require_once(e_PLUGIN . 'groupstyle/includes/groupstyle_class.php');

global $gs_obj;
if (!$gst_obj) {
	$gs_obj = new groupstyle();
}


if ($_POST) {
	$action = $_POST['action'];
	$from = $_POST['from'];
	$order = $_POST['order'];
	$banned = $_POST['banned'];
	$classlist = unserialize(stripslashes($_POST['classlist']));
} else if (e_QUERY) {
	$tmp = explode(".", e_QUERY);
	$action = $tmp[0];
	$from = intval(varset($tmp[1],0));
	$order = intval(varset($tmp[2],0));
	$invert = intval(varset($tmp[3],0));
	$banned = intval(varset($tmp[4],0));
	unset($tmp);
} else {
	$action = "show";
	$from = 0;
	$order = 0;
	$invert = 0;
	$banned = 0;
	$gs_obj->validateDBase();
}

if (!isset($classlist)) {
	$sql->db_Select("userclass_classes", "userclass_id, userclass_name");
	$clist = $sql->db_getList();
	foreach ($clist as $cls) {
		$classlist[$cls['userclass_id']] = $cls['userclass_name'];
	}
	
	$classlist[e_UC_ADMIN] = ADLAN_GST_GC12;
	$classlist[e_UC_MEMBER] = ADLAN_GST_GC11;
	
	asort($classlist);
} 


if(isset($_POST['updateUsers'])) {
	$old_prim = $_POST['old_primary'];
	$usr_classes = $_POST['usr_classes'];
	$changed = 0;
	
	while (list($uid, $prim) = each ($_POST['user_primary'])) {
		if ($prim != $old_prim[$uid]) {
			$result = $sql->db_Update("gstyle_user", "user_primary = $prim where user_user = $uid");
			//When Failed, try to insert (new user)
			if (!$result) {
				$result = $sql->db_Insert("gstyle_user", "$uid, $prim");
			}
			
			if ($result) $changed++;
			
			$clist = explode(",", $usr_classes[$uid]);
			if ($prim < 250 && !in_array($prim, $clist)) {
				$class = $usr_classes[$uid];
				$class .= ($class == "" ? $prim : ",$prim");
				$sql->db_Update("user", "user_class = '$class' where user_id = $uid"); 
			}
		}
	}
	
	$gst_msg = $changed . " " . ADLAN_GST_UC06;
}

if ($action == "show" || $action == "") {
	$gst_text = "
		<form action='".e_SELF."?show' id='dataform' method='post'>
		<table class='fborder' style='".ADMIN_WIDTH."'>
			<tr>
				<td class='fcaption' colspan='3' style='text-align:left'>" . ADLAN_GST_UC01 . "</td>
			</tr>
			<tr>
				<td class='forumheader2' colspan='3' style='text-align:left'><b>$gst_msg</b>&nbsp;</td>
			</tr>
		
			<tr>
				<td style='width:15%; text-align:center' class='fcaption'><strong>".getOrderLink(ADLAN_GST_UC02, 0)."</strong></td>
				<td style='width:60%; text-align:center' class='fcaption'><strong>".ADLAN_GST_UC03."</strong></td>
				<td style='width:25%; text-align:center' class='fcaption'><strong>".getOrderLink(ADLAN_GST_UC04,1)."</strong></td>
			</tr>
	";

	$bancheck = ($banned ? "" : " AND user_ban != 1 ");
	$count = $sql->db_Count("user", "(user_id)", " WHERE 1=1 $bancheck");
	
	$query = "
		SELECT
			s.*
			,user_name
			,user_admin
			,user_ban
			,user_class
		FROM
			#gstyle_user s,
			#user
		WHERE
			user_id = user_user
			$bancheck
		ORDER BY
			".getOrder($order, $invert)."
		LIMIT $from,$LISTSIZE
	";
	
	if ($sql->db_Select_gen($query)) {
		$uList = $sql->db_getList();

		foreach ($uList as $user) {
			$id = $user['user_user'];
			
			$gst_text .= "
				<tr>
					<td style='text-align:left' class='forumheader3'>".$user['user_name']. ($user['user_ban'] == 1 ? " <strong>[".ADLAN_GST_UC08."]</strong>" : "") ."</td>
					<td style='text-align:left' class='forumheader3'>".getUserClasses($user)."</td>
					<td style='text-align:center' class='forumheader3'>".getClassSelectBox($user['user_primary'], $id, $user['user_admin'], $user['user_class'])."</td>
				</tr>\n
			";
		}

	    $parms = $count . ",$LISTSIZE,$from," . e_SELF . "?$action.[FROM].$order.$invert.$banned";
	    $nextprev = $tp->parseTemplate("{NEXTPREV={$parms}}") . '';
		
		$gst_text .= "
			<tr>
				<td class='fcaption'>
					<input name='banned' value='1' type='checkbox' class='tbox' style='border:0;' " . ($banned == "1" ? 'checked="checked"':'') . " />
					".ADLAN_GST_UC05."
					<input type='hidden' name='action' value='show'/>
					<input type='submit' class='button' name='updateBanned' value='".ADLAN_GST_UC07."'/>
				</td>
				<td class='fcaption'>$nextprev &nbsp;</td>
				<td class='fcaption' style='text-align: center'>
					<input type='hidden' name='classlist' value='".serialize($classlist)."' />
					<input type='hidden' name='from' value='$from' />
					<input type='hidden' name='order' value='$order' />
					<input type='hidden' name='invert' value='$invert' />
					<input type='submit' class='button' name='updateUsers' value='".ADLAN_GST_UPD."' />
				</td>
				
			</tr>
		";
	} 
	
	$gst_text .= "</table></form>";
}

$ns->tablerender(ADLAN_GST_GC01, $gst_text);
require_once(e_ADMIN . 'footer.php');

function getUserClasses($user) {
	global $classlist;
	
	$retval = "";
	$list = explode(",", $user['user_class']);
	foreach($list as $class) {
		$tmp[] = $classlist[$class];
	}
	if ($user['user_admin']) {
		$tmp[] = $classlist[e_UC_ADMIN];
	}
	sort($tmp);
	foreach($tmp as $class) {
		if ($retval != "") $retval .= ", ";
		$retval .= ($class == $classlist[$user['user_primary']] ? "<strong>$class</strong>" : $class);
	}
	
	return $retval;
}

function getOrderLink($title, $curOrd, $action = "show") {
	global $order, $invert, $from;

	$start = 0;
	
	if ($order == $curOrd) {
		$img = '<img src="'.e_PLUGIN.'groupstyle/images/sort'.($invert ? 'dn' : 'up').'.png" border="0" />';
	} else {
		$img = '';
	}
	
	$link = "
		<a href='".e_SELF."?$action.$start.$curOrd.".($order == $curOrd && !$invert ? 1 : 0)."'>
			<strong>$title</strong></a>
	".$img;
	
	return $link;
}

function getOrder($order, $invert = false) {
	switch ($order) {
		/*
		 * 0	name
		 * 1	primary
		 */
		case 0:	return " user_name ".($invert ? "desc" : "asc");
		case 1:	return " user_primary ".($invert ? "asc" : "desc").", user_name asc ";
		default:
			return " user_name ".($invert ? "desc" : "asc");
	}
}

function getClassSelectBox($currval, $id, $admin, $classes) {
	global $classlist;
	
	reset($classlist);
	
	$box = "
		<input type='hidden' name='old_primary[$id]' value='$currval'/> 
		<input type='hidden' name='usr_classes[$id]' value='$classes'/>
		<select class='tbox' name='user_primary[$id]'>\n
	";
	
	$available = explode(",", $available);
	
	while (list($cid, $cname) = each($classlist)) {
		if ($cid != e_UC_ADMIN || ($cid == e_UC_ADMIN && $admin)) {
			$sel = ($cid == $currval ? "Selected='selected'" : "");
			$box .= "<option value='$cid' $sel >$cname</option>\n";
		}
	}
	$box .= "</select>\n";
	
	return $box;
}

?>