<?php
/**
 * $Id: e_module.php 9 2010-09-07 23:10:48Z michiel $
 * 
 * GroupStyle plugin for e107 v7xx - by Michiel Horvers
 * This module for the e107 .7+ website system
 * Copyright Michiel Horvers 2010
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * Initial Creation Date: 2 sep. 2010
 * $HeadURL: svn://ubusrv/echo2/GroupStyle/frontliners.eu/fl_plugins/groupstyle/e_module.php $
 * 
 * Revision: $LastChangedRevision: 9 $
 * Last Modified: $LastChangedDate: 2010-09-08 01:10:48 +0200 (wo, 08 sep 2010) $
 *
 */
if (!defined('e107_INIT')) {
    exit;
}

if (!isset($pref['plug_installed']['groupstyle'])) {
    return;
}

if (file_exists(e_PLUGIN . 'groupstyle/languages/' . e_LANGUAGE . '.php')) {
	include_lan(e_PLUGIN . 'groupstyle/languages/' . e_LANGUAGE . '.php');
} else {
	include_lan(e_PLUGIN . 'groupstyle/languages/English.php');
}


global $gstyle_obj, $override;

require_once(e_PLUGIN . 'groupstyle/includes/groupstyle_class.php');
if (!is_object($gstyle_obj)) {
    $gstyle_obj = new groupstyle();
}

$override->override_function('tablerender', 'groupstyle_tablerender', 1);
function groupstyle_tablerender($caption, $text, $mode = "default", $return = false){
	global $gstyle_obj;
	
	$inx = strpos($text, "user.php?id."); 
	//no need to do anything at all
	if ($inx === false) return;
	
	//apparently there are one of more usernames in here
	while ($inx !== false) {
		$inx += 12;
		$dubquote = false;
		$close = strpos($text, "'", $inx);
		if ($close === false) {
			$close = strpos($text, '"', $inx);
			$dubquote = true;
		}
		$inject_pos = strpos($text, ">", $close);
		$uid = substr($text, $inx, $close - $inx);
		$endname = strpos($text, "<", $inject_pos);
		$uname = substr($text, $inject_pos+1, $endname-$inject_pos-1);

		$style = $gstyle_obj->getRenderStyle($uid, $uname);
		if ($style !== false) {
			$inject = " $style";
			if ($dubquote) $inject = str_replace("'", '"', $inject);
			
			$text = substr($text, 0, $inject_pos) . $inject . substr($text, $inject_pos);
		}

		$inx = strpos($text, "user.php?id.", $endname + strlen($style)+8);
	}
	
	$retval['text'] = $text;
	
	return $retval;
	
}

?>