<?php
/**
 * $Id$
 * 
 * GroupStyle plugin for e107 v7xx - by Michiel Horvers
 * This module for the e107 .7+ website system
 * Copyright Michiel Horvers 2010
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * Initial Creation Date: 2 sep. 2010
 * $HeadURL$
 * 
 * Revision: $LastChangedRevision$
 * Last Modified: $LastChangedDate$
 *
 */

class groupstyle {
	
	function groupstyle() {
		global $GSTYLE_PREF;
		
		// get the preferences
		$this->load_prefs();
	}
	
	function getdefaultprefs() {
		global $GSTYLE_PREF;
		$GSTYLE_PREF = array(
			'memb_text' => 'Members'
			,'admin_text' => 'Admins'
		);
	}

	function save_prefs() {
		global $sql, $eArrayStorage, $GSTYLE_PREF;
		// save preferences to database
		if (!is_object($sql)) {
			$sql = new db;
		}
		$tmp = $eArrayStorage->WriteArray($GSTYLE_PREF);
		$sql->db_Update('core', "e107_value='$tmp' where e107_name='groupstyle'", false);
		return ;
	}

	function load_prefs() {
		global $sql, $eArrayStorage, $GSTYLE_PREF;

		// get preferences from database
		if (!is_object($sql)) {
			$sql = new db;
		}
		$num_rows = $sql->db_Select('core', '*', "e107_name='groupstyle' ");
		$row = $sql->db_Fetch();

		if (empty($row['e107_value'])) {
			// insert default preferences if none exist
			$this->getDefaultPrefs();
			$tmp = $eArrayStorage->WriteArray($GSTYLE_PREF);
			$sql->db_Insert('core', "'groupstyle', '$tmp' ");
			$sql->db_Select('core', '*', "e107_name='groupstyle' ");
		} else {
			$GSTYLE_PREF = $eArrayStorage->ReadArray($row['e107_value']);
		}
		
		return;
	}
	
	/**
	 * Returns the username as it should be displayed according to the group styles.<br/>
	 * 
	 * @param userid	The id of the user to show (default: current user)
	 * 
	 * @return String the user name to display
	 */
	function showUser($userid = USERID) {
		global $sql;
		
		$sql->db_Select("user", "user_name", "user_id = $userid");
		extract($sql->db_Fetch());
		$style = $this->getRenderStyle($userid, false);
		
		return "<a href='/user.php?id.$userid' $style>" . $user_name . "</a>";
	}
	
	function getRenderStyle($userid = USERID, $uname = false, $showTitle = true) {
		global $sql, $GSTYLE_PREF;
		
		$query = "
			SELECT
				user_name
				,user_class
				,user_admin
				,user_primary
			FROM
				#user,
				#gstyle_user
			WHERE
				user_id = $userid
				AND user_user = $userid
		";
		if ($sql->db_Select_gen($query)) {
			//user found
			extract($sql->db_Fetch());
			
			//User still in this class?
			$ucls = explode(",", $user_class);
			if (
				($user_primary == e_UC_ADMIN && !$user_admin)
				|| ($user_primary < 250 && !in_array($user_primary, $ucls))
			) {
				$user_primary = e_UC_MEMBER;
				$sql->db_Update("gstyle_user", "user_primary = $user_primary where user_user = $userid");
			}
		} else {
			//user not found
			if ($sql->db_Select("user", "user_name, user_class", "user_id = $userid")) {
				extract($sql->db_Fetch());

				if (!$user_class) {
					$user_primary = e_UC_MEMBER;
				} else {
					$list = explode(",", $user_class);
					if (count($list) > 1) {
						$user_primary = e_UC_MEMBER;
					} else {
						$user_primary = $list[0];
					}
				}
				
				$sql->db_Insert("gstyle_user", "$userid, $user_primary");
			} else {
				//user doesn't exists at all
				return false;
			}
		}
		
		if ($sql->db_Select("gstyle_style", "style_style", "style_class = $user_primary and style_custom = 1")) {
			//style is both known and enabled
			extract($sql->db_Fetch());
			$style = "style='$style_style'";
		} else {
			return false;
		}
		//username check requested?
		if ($uname !== false && $uname != $user_name) return false;
		
		if ($showTitle === true) {
			if ($user_primary == e_UC_ADMIN) {
				$userclass_name = $GSTYLE_PREF['admin_text'];
			} else if ($user_primary == e_UC_MEMBER) {
				$userclass_name = $GSTYLE_PREF['memb_text'];
			} else {
				$sql->db_Select("userclass_classes", "userclass_name", "userclass_id = $user_primary");
				extract($sql->db_Fetch());
			}
			
			$showTitle = $user_name." - ".$userclass_name;
		}
		
		if ($showTitle) $style .= " title='$showTitle'";
		
		return $style;
	}
	
	function getGroupStyle($classID) {
		global $sql;
		
		if ($sql->db_Select("gstyle_style", "style_style", "style_class = $classID and style_custom = 1")) {
			//style is both known and enabled
			extract($sql->db_Fetch());
			$style = "style='$style_style'";
		} else {
			return false;
		}
		
		return $style;
	}
	
	function validateDBase() {
		global $sql;
		
		//clear deleted users
		$query = "
			DELETE FROM
				#gstyle_user
			WHERE
				user_user not in (
					SELECT
						user_id
					FROM
						#user
				)
		";
		$sql->db_Select_gen($query);
		
		//insert new users
		$query = "
			SELECT
				user_id
				,user_class
			FROM
				#user
			WHERE
				user_id not in (
					SELECT
						user_user
					FROM
						#gstyle_user
				)
		";
		if ($sql->db_Select_gen($query)) {
			$list = $sql->db_getList();
			foreach($list as $user) {
				extract($user);
				if (!$user_class) {
					$user_primary = e_UC_MEMBER;
				} else {
					$clist = explode(",", $user_class);
					if (count($clist) > 1) {
						$user_primary = e_UC_MEMBER;
					} else{
						$user_primary = $clist[0];
					}
				}
				
				$sql->db_Insert("gstyle_user", "$user_id, $user_primary");
			}
		}
	}

	function getLegend() {
		global $sql, $pref, $mbl_obj, $GSTYLE_PREF;

		//find link with memberlist plugin
		if ($pref['plug_installed']['memberlist']) {
			if (!is_object($mbl_obj)) {
				require_once(e_PLUGIN.'memberlist/includes/memberlist_class.php');
				$mbl_obj = new memberlist();
			}
		}
		
		$legend = "";
		
		$query = "
				SELECT
					style_class
					,style_style
					,userclass_name
				FROM
					#gstyle_style,
					#userclass_classes
				WHERE
					style_style <> ''
					AND style_style is not null
					AND style_class = userclass_id
					AND style_custom = 1
					AND style_class < 250
			UNION
				SELECT
					style_class
					,style_style
					,'".$GSTYLE_PREF['admin_text']."' as userclass_name
				FROM
					#gstyle_style
				WHERE
					style_style <> ''
					AND style_style is not null
					AND style_custom = 1
					AND style_class = ".e_UC_ADMIN."
			UNION
				SELECT
					style_class
					,style_style
					,'".$GSTYLE_PREF['memb_text']."' as userclass_name
				FROM
					#gstyle_style
				WHERE
					style_style <> ''
					AND style_style is not null
					AND style_custom = 1
					AND style_class = ".e_UC_MEMBER."
			ORDER BY
				userclass_name
		";
		if ($sql->db_Select_gen($query)) {
			$glist = $sql->db_getList();
			foreach($glist as $group) {
				unset($link);
				if (is_object($mbl_obj)) {
					//Interaction with Memberlist plugin
					$url = $mbl_obj->getGroupLink($group['style_class']);
					if ($url) {
						$link['pre'] = "<a href='$url' title='".LAN_GST_MEMBERLIST."'>";
						$link['post'] = "</a>";
					}
				}
				$legend .= $link['pre']."<div style='".$group['style_style']."'>".$group['userclass_name']."</div>".$link['post'];
			}
		} else {
			$legend .= LAN_GST_NOLEGEND;
		}
		
		return $legend;
	}
	
	function getPrimary($user_id = USERID) {
		global $sql;
		
		if ($sql->db_Select("gstyle_user", "user_primary", "user_user = $user_id")) {
			$row = $sql->db_Fetch();
			return $row['user_primary'];
		}
		
		return false;
	}
	
	function setPrimary($class, $user_id = USERID) {
		global $sql;
		
		if (!$class) $class = e_UC_MEMBER;
		if ($user_id <= 0 || $class < 0) return false;
		
		//does the user already exists?
		if ($sql->db_Count("gstyle_user", "(*)", " WHERE user_user = $user_id") > 0 ) {
			return ($sql->db_Update("gstyle_user", "user_primary = $class where user_user = $user_id") === false ? false : true);
		} else {
			return ($sql->db_Insert("gstyle_user", "$user_id, $class") === false ? false : true);
		}
	}
	
}

?>