<?php
/**
 * $Id: plugin.php 22 2010-09-13 19:35:35Z michiel $
 * 
 * Group Style plugin for e107 v7xx - by Michiel Horvers
 * This module for the e107 .7+ website system
 * Copyright Michiel Horvers 2010
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * Initial Creation Date: 31 aug 2010
 * $HeadURL: svn://ubusrv/echo2/GroupStyle/frontliners.eu/fl_plugins/groupstyle/plugin.php $
 * 
 * Revision: $LastChangedRevision: 22 $
 * Last Modified: $LastChangedDate: 2010-09-13 21:35:35 +0200 (ma, 13 sep 2010) $
 *
 */
if (!defined('e107_INIT')) {
    exit;
}

// ***************************************************************
// *
// *		Title		:	Group Style
// *
// *		Author		:	Michiel Horvers
// *
// *		Date		:	August 31st 2010
// *
// *		Version		:	1.1
// *
// *		Description	: 	Shows all of the user's unread posts
// *
// *		Revisions	:	1.0		1-09-2010	Initial revision
// *						1.1		14-09-2010	Added API functions for other plugs
// *
// *		Support at	:	http://www.mhcp-software.nl
// *						http://wiki.mhcp-software.nl
// *
// ***************************************************************
include_lan(e_PLUGIN . 'groupstyle/languages/admin/' . e_LANGUAGE . '.php');
// Plugin info -------------------------------------------------------------------------------------------------------
$eplug_name = 'GroupStyle';
$eplug_version = '1.1';
$eplug_author = 'Michiel Horvers';
$eplug_url = 'http://www.mhcp-software.nl';
$eplug_email = 'michiel@mhcp-software.nl';
$eplug_description = ADLAN_GST_PM_02;
$eplug_compatible = 'e107v0.7.11+';
$eplug_readme = '';	// leave blank if no readme file
$eplug_status = TRUE;
$eplug_compliant=true;


// Name of the plugin's folder -------------------------------------------------------------------------------------
$eplug_folder = 'groupstyle';

// Name of menu item for plugin ----------------------------------------------------------------------------------
$eplug_menu_name = ADLAN_GST;

// Name of the admin configuration file --------------------------------------------------------------------------
$eplug_conffile = 'admin_user.php';

// Icon image and caption text ------------------------------------------------------------------------------------
$eplug_icon = $eplug_folder . '/images/groupstyle_32.png';
$eplug_icon_small = $eplug_folder . '/images/groupstyle_16.png';
$eplug_caption = ADLAN_GST_PM_01;

// prefs created in class

// create tables -----------------------------------------------------------------------------------------------
$eplug_sql = file_get_contents(e_PLUGIN . "{$eplug_folder}/groupstyle_sql.php");
preg_match_all("/CREATE TABLE (.*?)\(/i", $eplug_sql, $matches);
$eplug_table_names = $matches[1];
// List of sql requests to create tables -----------------------------------------------------------------------------
// Apply create instructions for every table you defined in locator_sql.php --------------------------------------
// MPREFIX must be used because database prefix can be customized instead of default e107_
$eplug_tables = explode(';', str_replace('CREATE TABLE ', 'CREATE TABLE ' . MPREFIX, $eplug_sql));
for ($i = 0; $i < count($eplug_tables); $i++)
{
    $eplug_tables[$i] .= ';';
}
array_pop($eplug_tables); // Get rid of last (empty) entry

// Create a link in main menu (yes=TRUE, no=FALSE) -------------------------------------------------------------
$eplug_link = FALSE;
$eplug_link_name = '';
$eplug_link_url = '';


// Text to display after plugin successfully installed ------------------------------------------------------------------
$eplug_done = ADLAN_GST_PM_03;


// upgrading ... //

$upgrade_add_prefs = "";

$upgrade_remove_prefs = "";

$upgrade_alter_tables = "";

$eplug_upgrade_done = ADLAN_GST_PM_04;

if ($version = $pref['plug_installed']['groupstyle']) {
	$gst_major = intval(substr($version, 0, strpos($version, ".")));
	$version = substr($version, strpos($version, ".")+1);
	if (strpos($version, ".")) {
		$gst_minor = intval(substr($version, 0, strpos($version, ".")));
		$gst_patch = intval(substr($version, strpos($version, ".")+1));
	} else {
		$gst_minor = intval($version);
		$gst_patch = 0;
	}
} else {
	$gst_major = 0;
	$gst_minor = 0;
	$gst_patch = 0;
}


// Deleting plugin ...//
if (!function_exists('groupstyle_uninstall')) {
    function groupstyle_uninstall() {
        // get rid of the things we created
        global $sql;
        $sql->db_Delete('core', ' e107_name="groupstyle" ');
    }
}

// Upgrade plugin ...//
/*
if (!function_exists('groupstyle_upgrade')) {
    function groupstyle_upgrade() {
    	global $gst_major, $gst_minor, $gst_patch, $sql, $upgrade_alter_tables;
    	
    	if ($gst_major == 1 && $gst_minor < 1) {
			$upgrade_alter_tables = array (
				"ALTER TABLE " . MPREFIX . "evo_alliance ADD slave_stat varchar(10) NOT NULL default 'NEUTRAL' AFTER all_stat;"
				,"ALTER TABLE " . MPREFIX . "evo_city ADD slave_user int(10) unsigned NOT NULL default '0' AFTER cty_user;"
				,"ALTER TABLE " . MPREFIX . "evo_city ADD cty_uname varchar(50) default NULL AFTER slave_user;"
				,"ALTER TABLE " . MPREFIX . "evo_city ADD slave_cat varchar(10) default NULL AFTER cty_cat;"
				,"ALTER TABLE " . MPREFIX . "evo_city ADD slave_target char(1) NOT NULL default 'F' AFTER cty_target;"
				,"UPDATE " . MPREFIX . "evo_city set cty_uname = (select user_name from " . MPREFIX ."user where user_id = cty_user);"
				,"UPDATE " . MPREFIX . "evo_city set slave_cat = 'NEUTRAL';"
				,"ALTER TABLE " . MPREFIX . "evo_scout ADD slave_user int(10) unsigned NOT NULL default '0' AFTER sct_user;"
				,"ALTER TABLE " . MPREFIX . "evo_scout ADD sct_uname varchar(50) default '' AFTER slave_user;"
				,"UPDATE " . MPREFIX . "evo_scout set sct_uname = (select user_name from " . MPREFIX ."user where user_id = sct_user);"
			);
    	}
    }
}
*/


?>